/*
 * lcd.h
 */

#define LCD_CMD_HIGHBITS(cmd) (((1<<0 & ((cmd)>>4 & 0x0F)) >> 0) << module.datapins[0]) | (((1<<1 & ((cmd)>>4 & 0x0F)) >> 1) << module.datapins[1]) | (((1<<2 & ((cmd)>>4 & 0x0F)) >> 2) << module.datapins[2]) | (((1<<3 & ((cmd)>>4 & 0x0F)) >> 3) << module.datapins[3])
#define LCD_CMD_LOWBITS(cmd) (((1<<0 & ((cmd) & 0x0F)) >> 0) << module.datapins[0]) | (((1<<1 & ((cmd) & 0x0F)) >> 1) << module.datapins[1]) | (((1<<2 & ((cmd) & 0x0F)) >> 2) << module.datapins[2]) | (((1<<3 & ((cmd) & 0x0F)) >> 3) << module.datapins[3])

// komennot
#define LCD_CLEARDISPLAY 0x01
#define LCD_RETURNHOME 0x02
#define LCD_ENTRYMODESET 0x04
#define LCD_DISPLAYCONTROL 0x08
#define LCD_CURSORSHIFT 0x10
#define LCD_FUNCTIONSET 0x20
#define LCD_SETCGRAMADDR 0x40
#define LCD_SETDDRAMADDR 0x80

// nayton merkkien tulostusasetukset
#define LCD_ENTRYRIGHT 0x00
#define LCD_ENTRYLEFT 0x02
#define LCD_ENTRYSHIFTINCREMENT 0x01
#define LCD_ENTRYSHIFTDECREMENT 0x00

// nayton alustusasetukset
#define LCD_DISPLAYON 0x04
#define LCD_DISPLAYOFF 0x00
#define LCD_CURSORON 0x02
#define LCD_CURSOROFF 0x00
#define LCD_BLINKON 0x01
#define LCD_BLINKOFF 0x00

// liput nayton kursorin siirtoon
#define LCD_DISPLAYMOVE 0x08
#define LCD_CURSORMOVE 0x00
#define LCD_MOVERIGHT 0x04
#define LCD_MOVELEFT 0x00

// liput alustusfunktioille
#define LCD_8BITMODE 0x10
#define LCD_4BITMODE 0x00
#define LCD_2LINE 0x08
#define LCD_1LINE 0x00
#define LCD_5x10DOTS 0x04
#define LCD_5x8DOTS 0x00

struct lcdmodule {
	unsigned char rs;
	unsigned char en;
	unsigned char datapins[4];
};

void lcd_send_command(struct lcdmodule module, unsigned char cmd);
void lcd_send_data(struct lcdmodule module, unsigned char cmd);
struct lcdmodule lcd_init(unsigned char en, unsigned char rs, unsigned char d4, unsigned char d5, unsigned char d6, unsigned char d7);
void lcd_clear(struct lcdmodule module);
void lcd_print(struct lcdmodule module, char *s);
void lcd_goto_xy(struct lcdmodule module, unsigned char x, unsigned char y);
